require 'json'

module Grid
  class Command
    attr_accessor :name, :params

    def initialize(name, params)
      @name, @params = name, params
    end

    def self.parse(body)
      return if body == ''

      data = JSON.parse(body)

      cmd = Command.new(
        data['name'].to_sym,
        data['params']
      )

      cmd
    end

    def encode
      JSON.unparse(
        :name => @name,
        :params => @params
      )
    end
  end
end