require 'grid/command_handler'
require 'grid/fake_stdin'
require 'grid/zmq/stdin'

module Grid
  class Node
    def initialize
      @handler = CommandHandler.new
    end

    def listen(stdin, address)
      stdin.listen(address) do |command|
        @handler.on_command(command)
      end
    end

    def command(name, &block)
      @handler.register_command(name, &block)
    end
  end
end