module Grid
  module ZMQ
    class Socket
      def initialize(type)
        ctx = ::ZMQ::Context.create
        @socket = ctx.socket(type)
      end

      def send(method, *attrs)
        error_check(@socket.send(method, *attrs))
      end

      private

      def error_check(code)
        if ::ZMQ::Util.resultcode_ok?(code)
          false
        else
          STDERR.puts "Operation failed, errno [#{::ZMQ::Util.errno}] description [#{::ZMQ::Util.error_string}]"
          caller(1).each { |callstack| STDERR.puts(callstack) }
          true
        end
      end
    end
  end
end